/***************************************************************
*                                                              *
*  Robótica educacional: atividades com o Kit Criatecno CT100  *
*                          2a Edição                           *
*                                                              *
*                          CRIATECNO                           *
*                     www.criatecno.com.br                     *
*                                                              *
***************************************************************/

// Atividade 37 - Seguidor de parede
#include <Servo.h> 
Servo servoDireito;
Servo servoEsquerdo;
int echo = 7;
int trig = 8;
int motorDireito = 6;
int motorEsquerdo = 9;
int ajuste;
long tempo;
long distancia;
long distancia1;
long distancia2;
long distanciaMedia;
long distanciaConsiderada;
void setup() {
  pinMode(echo, INPUT);
  pinMode(trig, OUTPUT);
  servoDireito.attach(motorDireito);
  servoEsquerdo.attach(motorEsquerdo);
}
void loop() {
  distancia1 = ultrassom();
  delay(10);
  distancia2 = ultrassom();
  distanciaMedia = (distancia1 + distancia2) / 2;
  distanciaConsiderada = constrain(distanciaMedia, 20, 30);
  ajuste = map(distanciaConsiderada, 20, 30, -250, 200);
  servoDireito.writeMicroseconds(1650 + ajuste);
  servoEsquerdo.writeMicroseconds(1150 + ajuste);
  delay(60);    
}
long ultrassom() {
  digitalWrite(trig, HIGH);
  delayMicroseconds(10); 
  digitalWrite(trig, LOW);
  tempo = pulseIn(echo, HIGH);
  distancia = ((tempo / 29) / 2);
  return distancia;
}
