/***************************************************************
*                                                              *
*  Robótica educacional: atividades com o Kit Criatecno CT100  *
*                          2a Edição                           *
*                                                              *
*                          CRIATECNO                           *
*                     www.criatecno.com.br                     *
*                                                              *
***************************************************************/

// Atividade 36 - Navegação com sensor de ultrassom
#include <Servo.h> 
Servo servoDireito;
Servo servoEsquerdo;
int echo = 7;
int trig = 8;
int motorDireito = 6;
int motorEsquerdo = 9;
int limite = 15;
int tempoFrente = 20;
int tempoTras = 200;
int tempoEsquerda = 400;
long tempo;
long distancia;
long distancia1;
long distancia2;
long distanciaMedia;
void setup() {
  pinMode(echo, INPUT);
  pinMode(trig, OUTPUT);
  servoDireito.attach(motorDireito);
  servoEsquerdo.attach(motorEsquerdo);
}
void loop() {
  distancia1 = ultrassom();
  delay(10);
  distancia2 = ultrassom();
  distanciaMedia = (distancia1 + distancia2) / 2;
  if (distanciaMedia > limite) {
    servoDireito.writeMicroseconds(2000);
    servoEsquerdo.writeMicroseconds(1000);
    delay(tempoFrente);
  }
  else {
    servoDireito.writeMicroseconds(1000);
    servoEsquerdo.writeMicroseconds(2000);
    delay(tempoTras);
    servoDireito.writeMicroseconds(2000);
    servoEsquerdo.writeMicroseconds(2000);
    delay(tempoEsquerda);
  }
}
long ultrassom() {
  digitalWrite(trig, HIGH);
  delayMicroseconds(10); 
  digitalWrite(trig, LOW);
  tempo = pulseIn(echo, HIGH);
  distancia = ((tempo / 29) / 2);
  return distancia;
}
